//+------------------------------------------------------------------+
//|                                       SendNotificationSample.mq5 |
//|                        Copyright 2012, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2012, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"

#define XRGB(r,g,b)    (0xFF000000|(uchar(r)<<16)|(uchar(g)<<8)|uchar(b))
//---   
#include <ChartObjects\ChartObjectsTxtControls.mqh>
//#include <ChartObjects\ChartObjectsShapes.mqh>
#include <ChartObjects\ChartObjectsBmpControls.mqh>
//---     
CChartObjectBmpLabel Form;
//---  
CChartObjectEdit   InputText;
//---   
CChartObjectButton SendButton;
string sendbutton_name="SendButton";
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
   int subwindow=0;
//---  BitmapLabel,        
   Form.Create(0,"Form",subwindow,100,50);
   string res_name="::Canvas";              //     
//---    
   uint  data[];
   ArrayResize(data,400*100);               //      
   ArrayInitialize(data,uCLR(clrBisque));   //  
   ResourceCreate(res_name,data,400,100,0,0,0,COLOR_FORMAT_XRGB_NOALPHA);
   Form.BmpFileOn(res_name);                //     
//---   
   InputText.Create(0,"InputText",subwindow,130,70,320,25);
   InputText.Description("");          //   
   InputText.BackColor(clrWhite);      //  
   InputText.BorderColor(clrSlateGray);//  
   InputText.Color(clrBlack);          //  
//---  
   SendButton.Create(0,sendbutton_name,subwindow,130,110,100,30);
   SendButton.Description("");
//---  ,    
   ChartRedraw();
//---
   return(0);
  }
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
//---      
   if(id==CHARTEVENT_OBJECT_CLICK)
     {
      string clickedChartObject=sparam;
      //---      
      if(clickedChartObject==sendbutton_name)
        {
         //---   -    
         bool pressed=ObjectGetInteger(0,sendbutton_name,OBJPROP_STATE);
         //---    
         if(pressed)
           {
            Print(" : ",InputText.Description());
            //---  
            bool result=SendNotification(InputText.Description());
            //---  ,    
            Sleep(100);
            //---  
            ObjectSetInteger(0,sendbutton_name,OBJPROP_STATE,0);
            //---  
            if(!result)
              {
               //---    
               MessageBox(" : "+(string)GetLastError(),"    SendNotification()!");
               //---      
               if(GetLastError()==4517)
                 {
                  Print("    SendNotification()!",
                  "      (  ID       Push-)");
                 }               
              }
           }

        }
     }
   ChartRedraw();//      
  }
//+------------------------------------------------------------------+
//|     color  uint          |
//+------------------------------------------------------------------+
uint uCLR(const color clr)
  {
   return(XRGB((clr)&0x0FF,(clr)>>8,(clr)>>16));
  };
//+------------------------------------------------------------------+
